define(['app', 'js/utils/tips'], function(app, Tips) {
    app.controller('indexProDetailCtrl', ['$scope', 'httpRequest', 'Storage', '$state', '$ionicSlideBoxDelegate', '$window', '$ionicHistory',
        function($scope, httpRequest, Storage, $state, $ionicSlideBoxDelegate, $window, $ionicHistory) {
            $scope.$on("$ionicView.beforeEnter", function() {
                $scope.isIOSApp = APP.isInApp && APP.isIOS;
                var auth = $scope.auth = Storage.get('vrsm_auth');
                $scope.goodId = $state.params.goodId;
                $scope.fromNotification = $state.params.fromNotification;
                $scope.isShare = $state.params.isShare == 'share';
                $scope.standard = -1;
                $scope.input = { goodNum: 1 };
                //根据屏幕宽度初始化swiper的高度
                initSwiperHeight(750 / 750, function() {
                    // 获取商品详情
                    httpRequest.post('?method=shop.goodInfo', { id: $scope.goodId }, function(re) {
                        if (re.data.state) {
                            $scope.good = re.data.data;
                            $ionicSlideBoxDelegate.update();
                        }
                    }, function(re) {
                        Tips.showTips(re.data.msg);
                    });
                });


                // 返回上一页
                $scope.goHistory = function() {
                    if ($scope.fromNotification == 'true') {
                        $state.go("tab.index");
                    } else {
                        APP.isInApp ? $ionicHistory.goBack() : history.back();
                    }
                }

                //获取评论列表(前2项)
                httpRequest.post('?method=shop.shopCommentList', { page: 1, each: 2, good_id: $scope.goodId }, function(re) {
                    if (re.data.state) {
                        var data = re.data.data;
                        $scope.averageStar = data.average_star;
                        $scope.commentList = data.list;
                    }
                }, function(re) {});
                if (auth) {
                    //检查收藏状态
                    httpRequest.postWithAuth($scope, '?method=cms.checkCollect', { type: 2, collect_id: $scope.goodId }, function(re) {
                        if (re.data.state) {
                            $scope.isCollect = re.data.data.is_collect;
                        }
                    }, function(re) {});
                }
            });
            //选择型号
            $scope.chooseStandard = function(v, index) {
                $scope.input.goodNum = 1;
                if ($scope.standard == index) {
                    $scope.standard = -1;
                    $scope.nowStandard = undefined;
                    return;
                }
                $scope.standard = index;
                $scope.nowStandard = v;
            };
            //跳转购物车
            $scope.jumpCart = function() {
                if (!$scope.auth) {
                    Tips.showTips('请先登录');
                    return;
                }
                $state.go('cart');
            };
            //收藏商品
            $scope.collect = function() {
                if (!$scope.auth) {
                    Tips.showTips('请先登录');
                    return;
                }
                httpRequest.postWithAuth($scope, '?method=cms.saveCollect', { type: 2, collect_id: $scope.goodId }, function(re) {
                    if (re.data.state) {
                        Tips.showTips("收藏成功");
                        $scope.isCollect = 1;
                    }
                }, function(re) {
                    Tips.showTips(re.data.msg);
                });
            };
            //分享到其他平台
            $scope.shareWechat = function(type) {
                var data = {
                    "title": $scope.good.name,
                    "content": $scope.good.abstract,
                    "imgUrl": $scope.good.cover,
                    "targetUrl": APP.shareUrl + '#/indexProDetail/' + $scope.good.id + '/share/'
                }
                dmwechat.share(type, data, function(re) {
                    Tips.showTips('分享成功');
                }, function(re) {
                    Tips.showTips('分享失败');
                });
                $scope.sharePop = false;
            };
            //修改商品数量
            $scope.validate = function(action) {
                if (!$scope.nowStandard) {
                    Tips.showTips('请先选择型号');
                    return;



                }
                if ($scope.nowStandard.stock == 0) {
                    Tips.showTips('该型号已没有库存');
                    return;
                }
                if (action == 'add') {
                    $scope.addNum();
                } else {
                    $scope.reduceNum();
                }
            };
            $scope.numCtrl = function() {
                if ($scope.input.goodNum < 1) {
                    $scope.input.goodNum = 1;
                }
                if (Number($scope.input.goodNum) >= $scope.nowStandard.stock) {
                    $scope.input.goodNum = Number($scope.nowStandard.stock);
                }
            };
            $scope.reduceNum = function() {
                if ($scope.input.goodNum == 1) {
                    Tips.showTips('最少购买数量为1');
                    return;
                }
                $scope.input.goodNum--;
            };
            $scope.addNum = function() {
                if ($scope.input.goodNum >= $scope.nowStandard.stock) {
                    Tips.showTips('已没有更多的库存');
                    return;
                }
                $scope.input.goodNum++;
            };
            //加入购物车
            $scope.addCart = function() {
                var postData = validateAndGenerate();
                if (postData) {
                    httpRequest.postWithAuth($scope, '?method=shop.addShopCart', postData, function(re) {
                        if (re.data.state) {
                            Tips.showTips("添加购物车成功");
                            $scope.popHide("standardPop");
                        }
                    }, function(re) {
                        Tips.showTips(re.data.msg);
                    });
                }
            };
            //立即购买
            $scope.buyNow = function() {
                var postData = validateAndGenerate();
                if (postData) {
                    httpRequest.postWithAuth($scope, '?method=shop.addShopCart', postData, function(re) {
                        if (re.data.state) {
                            $state.go('confirmOrder', { cartIds: re.data.data.cart_id });
                        }
                    }, function(re) {
                        Tips.showTips(re.data.msg);
                    });
                }
            };
            //确认型号选择
            $scope.confirmStandard = function() {
                if (!$scope.nowStandard || $scope.nowStandard.stock == 0) {
                    Tips.showTips('该型号已没有库存');
                    return;
                }
                $scope.popHide('standardPop');
            };
            $scope.popShow = function(popName) {
                $scope[popName] = true;
                $scope.chooseStandard($scope.good.stock[0], 0);
            };
            $scope.popHide = function(popName) {
                $scope[popName] = false;
                $scope.standard = -1;
                $scope.nowStandard = undefined;
            };

            function initSwiperHeight(percent, callBackFunc) {
                var width = document.body.clientWidth;
                var height = width / percent;
                var swipers = angular.element(document.getElementsByClassName('swiper'));
                swipers.css('height', height + 'px');
                if (typeof callBackFunc == 'function') callBackFunc();
            }

            function validateAndGenerate() {
                if (!$scope.auth) {
                    Tips.showTips('请先登录');
                    return undefined;
                }
                if (!$scope.nowStandard) {
                    if ($scope.standardPop) {
                        Tips.showTips('请选择型号');
                    } else {
                        $scope.popShow('standardPop');
                    }
                    return undefined;
                }
                var postData = {
                    good_id: $scope.goodId,
                    stock_id: $scope.nowStandard.id,
                    quantity: $scope.input.goodNum
                }
                return postData;
            }
        }
    ]);
});
